<?php

/**
 * @file
 * The form of account setting
 */

/**
 * Callback for hook_menu().
 */
function cleeng_account_form($form_state) {
  global $user;
  drupal_add_css(drupal_get_path('module', 'cleeng') . '/css/cleeng-backend.css');

  $cleeng = cleeng_client();
  unset($_COOKIE['CleengClientAccessToken']);
  $cleeng->logout();
  $token = variable_get('cleeng_token_from_uid_' . $user->uid, '');

  $form = array();

  if (!$token) {
    $login = l(t('Link my cleeng account'), 'cleeng/ajax', array('query' => array('cleengMode' => 'auth', 'cleengPopup' => 1), 'attributes' => array('onclick' => "window.open(this.getAttribute('href'), 'cleeng_popup', 'popup'); return false;")));
    $publisher = l(t('Register as publisher'), CLEENG_URL . 'publisher-registration', array('attributes' => array('target' => '_blank')));
    $form['information'] = array(
      '#value' => theme_item_list(array($login, $publisher)),
    );
  }
  else {
    $userinfo = $cleeng->getUserInfo();
    if (!$userinfo) {
      drupal_set_message(t('Please link your account again'));
      variable_del('cleeng_token_from_uid_' . $user->uid);
      drupal_goto('user/' . $user->uid . '/cleeng');
    }
    $userimage = $cleeng->getPublisherLogoUrl($userinfo['id']);
    variable_set('cleeng_currency_symbol_from_uid_' . $user->uid, $userinfo['currencySymbol']);
    variable_set('cleeng_currency_from_uid_' . $user->uid, $userinfo['currency']);
    if ($userinfo['name']) {
      $form['information'] = array(
        '#value' => '<img id="cleeng-account-img" src="' . $userimage . '" /><h3 id="cleeng-account-name">' . $userinfo['name'] . '</h3>',
      );
    }
    if ($userinfo['accountType'] != 'publisher' && $userinfo['accountType']) {
      drupal_set_message(t('You need to have a Publisher account before using this widget. Please upgrade your account: <a target="_blank" href="@upgrade-page">Become publisher</a>.', array('@upgrade-page' => url(CLEENG_URL . 'edit-profile/upgrade/1'))), 'error');
    }
  }

  if ($userinfo['name'] || $userinfo['accountType'] != 'publisher' && $userinfo['accountType']) {
    $form['submit'] = array(
      '#prefix' => '<div class="clear-block"></div>',
      '#type' => 'submit',
      '#value' => t('Unlink'),
    );
  }

  $form['clear'] = array(
    '#value' => '<div class="clear-block"></div>',
  );

  return $form;
}

/**
 * Submit function for the settings form
 */
function cleeng_account_form_submit($form, &$form_state) {
  global $user;
  variable_del('cleeng_token_from_uid_' . $user->uid);
}

