<?php

/**
 * @file
 * The form of admin setting
 */

/**
 * cleeng parameters form for admin console
 */
function cleeng_admin_setting() {
  $fomr = array();

  $form['cleeng_textabovelayer'] = array(
    '#type' => 'checkbox',
    '#post_render' => array('cleeng_add_label'),
    '#title' => t('Enable text above layer'),
    '#description' => 'With protected content, Cleeng would automatically add a short text above the layer. This text will increase the likelyhood to buy for consumers. If you prefer to write this text yourself just, just un-tick the box below.',
    '#default_value' => variable_get('cleeng_textabovelayer', 'true'),
  );

  $form['cleeng_environment'] = array(
    '#type' => 'radios',
    '#title' => t('Payment activation mechanism'),
    '#required' => TRUE,
    '#description' => 'Here you can select if you want to enable real transactions and earn money (LIVE) or just experiment and test with the Cleeng service using the sandbox environment (SANDBOX). In case you have selected "SANDBOX", please avoid covering content on your public website as your visitors might be very confused. Also note that your settings, content references and accounts are NOT copied in between SANDBOX servers and the LIVE servers. So only use SANDBOX if you want to test on a non-public website.',
    '#options' => array('sandbox' => t('SANDBOX (test transactions)'), 'production' => t('LIVE (real transactions!)')),
    '#default_value' => variable_get('cleeng_environment', 'production'),
  );

  $form['cleeng_paypal'] = array(
    '#type' => 'radios',
    '#title' => t('You may choose between 2 different payment options on the Cleeng layers'),
    '#default_value' => variable_get('cleeng_paypal', 0),
    '#description' => t('Note: PayPal only payments are applicable for payments above 0.49 cents. All other functionalities (user library, social commission) will remain identical.'),
    '#options' => array(
      t('<strong>Standard:</strong> Multiple payment options including PayPal, using credits stored on the Cleeng account'),
      t('<strong>PayPal only:</strong> Direct PayPal Digital Goods payment from the layer'),
    ),
  );

  return system_settings_form($form);
}

/**
 * Adding a label to a single checkbox
 */
function cleeng_add_label($content, $element) {
  $content = str_replace('-wrapper">', '-wrapper"><label>Text above layer:</label>', $content);
  return $content;
}

