<?php

/**
 * @file
 * Cleeng class
 */

class DrupalCleengClient extends CleengClient {

    /**
     * Load access token.
     * @return
     *   string
     */
  public function loadAccessToken() {
    // Read access token from cookie */
    global $user;
    if ($user->uid > 0) {
      if (variable_get('cleeng_token_from_uid_' . $user->uid, parent::loadAccessToken())) {
        return variable_get('cleeng_token_from_uid_' . $user->uid, parent::loadAccessToken());
      }
    }
    else {
      return parent::loadAccessToken();
    }
    return NULL;
  }

  /**
   * Save access token in cookie.
   *
   * @param string $accessToken
   *   AccesToken
   * @param int $expires
   *   Expires
   */
  public function storeAccessToken($access_token, $expires) {
    global $user;
    if ($user->uid > 0) {
      variable_set('cleeng_token_from_uid_' . $user->uid, $access_token);
    }
    else {
      setcookie($this->_cookieName, $access_token, $expires, $this->_cookiePath);
    }
  }

  /**
   * Returns access token.
   * @return
   *   string
   */
  public function getAccessToken($token = NULL) {
    if (NULL === $this->_accessToken) {
      if ($token) {
        $this->_accessToken = $token;
      }
      else {
        $this->_accessToken = $this->loadAccessToken();
      }
    }
    return $this->_accessToken;
  }
}

