<?php

/**
 * @file
 * Cleeng item form
 */

/**
 * Form for a cleeng item
 */
function cleeng_item_form($form_state) {
  if ($form_state['submitted'] == FALSE && $_GET['id']) {
    $form_state['values']['description'] = $_GET['description'];

    $prices = cleeng_price_array();
    $key = array_search($_GET['price'], $prices);
    $form_state['values']['price'] = $key;

    if ($_GET['ls'] != '-' || $_GET['le'] != '-') {
      $form_state['values']['layer_dates'] = 1;
      $_GET['ls'] != '-' ? $form_state['values']['from'] = $_GET['ls'] : FALSE;
      $_GET['le'] != '-' ? $form_state['values']['to'] = $_GET['le'] : FALSE;
    }

    $_GET['id'] ? $form_state['values']['cleeng_id'] = $_GET['id'] : FALSE;

    if ($_GET['referral'] != '-') {
      $form_state['values']['referral'] = $_GET['referral'];
      $form_state['values']['referral_enable'] = 1;
    }
  }

  // Initial javascripts and css */
  global $user;
  jquery_ui_add(array('ui.core', 'ui.slider'));
  if ($path = libraries_get_path('selecttouislider')) {
    drupal_add_js($path . '/js/selectToUISlider.jQuery.js');
  }
  if ($path = libraries_get_path('fieldselection')) {
    drupal_add_js($path . '/jquery-fieldselection.js');
  }
  if ($path = libraries_get_path('charcount')) {
    drupal_add_js($path . '/charCount.js');
  }
  drupal_add_js(drupal_get_path('module', 'cleeng') . '/js/cleeng-item-form.js');
  drupal_add_js(array('cleeng' => array('currency' => variable_get('cleeng_currency_symbol_from_uid_' . $user->uid, ''))), 'setting');
  drupal_add_css(jquery_ui_get_path() . '/themes/base/ui.all.css');
  drupal_add_css(drupal_get_path('module', 'cleeng') . '/css/cleeng-backend.css');
  modalframe_child_js();

  $form = array();

  $form['description'] = array(
    '#type' => 'textfield',
    '#title' => t('Description'),
    '#default_value' => $form_state['values']['description'],
    '#maxlength' => 110,
    '#size' => 40,
    '#required' => TRUE,
  );

  $form['cleeng_text'] = array(
    '#type' => 'textarea',
    '#title' => t('Cleeng text'),
    '#wysiwyg' => FALSE,
    '#default_value' => $form_state['values']['cleeng_text'],
    '#prefix' => '<div id="cleeng-hidden-form">',
  );

  $form['cleeng_id'] = array(
    '#type' => 'textfield',
    '#title' => t('Cleeng id'),
    '#default_value' => $form_state['values']['cleeng_id'],
  );

  $form['text_start'] = array(
    '#type' => 'textfield',
    '#title' => t('Start'),
    '#default_value' => $form_state['values']['text_start'],
  );

  $form['text_end'] = array(
    '#type' => 'textfield',
    '#title' => t('End'),
    '#default_value' => $form_state['values']['text_end'],
    '#suffix' => '</div>',
  );

  $form['price'] = array(
    '#type' => 'select',
    '#title' => t('Price'),
    '#default_value' => $form_state['values']['price'],
    '#options' => price_array(),
    '#required' => TRUE,
  );

  $form['layer_dates'] = array(
    '#type' => 'checkbox',
    '#title' => t('Enable layer dates'),
    '#default_value' => $form_state['values']['layer_dates'],
  );

  $form['layer_dates_wrapper'] = array(
    '#prefix' => '<div id="layer-dates-wrapper">',
    '#suffix' => '</div>'
  );

  $form['layer_dates_wrapper']['from'] = array(
    '#title' => t('From'),
    '#default_value' => $form_state['values']['from'],
    '#type' => 'date_popup',
  );

  $form['layer_dates_wrapper']['to'] = array(
    '#title' => t('To'),
    '#default_value' => $form_state['values']['to'],
    '#type' => 'date_popup',
  );

  $form['referral_enable'] = array(
    '#type' => 'checkbox',
    '#default_value' => $form_state['values']['referral_enable'],
    '#title' => t('Enable referral program'),
  );

  $form['referral'] = array(
    '#type' => 'textfield',
    '#title' => t('Referral rate'),
    '#default_value' => $form_state['values']['referral'],
    '#suffix' => '<div id="referral-slider"></div>'
    // '#default_value' => $node->title */
  );

  $form['submit'] = array('#type' => 'submit', '#value' => t('Save markers'));

  $form['cancel'] = array('#type' => 'submit', '#value' => t('Cancel'));

  return $form;
}

/**
 * Form validation for a cleeng item
 */
function cleeng_item_form_validate($form, &$form_state) {
  if ($form_state['clicked_button']['#id'] == 'edit-cancel') {
    // Cancel button has been clicked */
    modalframe_close_dialog();
  }
}

/**
 * Form submit for a cleeng item
 */
function cleeng_item_form_submit($form, &$form_state) {
  // Get prices array */
  $prices = price_array();

  if ($form_state['values']['cleeng_id']) {
    $cleeng_id = $form_state['values']['cleeng_id'];
  }
  else {
    $_SESSION['cleeng_temp_count']++;
    $cleeng_id = 't' . $_SESSION['cleeng_temp_count'];
  }

  if ($form_state['values']['referral']) {
    if (drupal_strlen($form_state['values']['referral']) == 1) {
      $referral_float = '0.0' . $form_state['values']['referral'];
    }
    else {
      $referral_float = '0.' . $form_state['values']['referral'];
    }
  }
  else {
    $referral_float = '-';
  }

  // Send new data back to the parent frame */
  modalframe_close_dialog(array(
    'id' => $cleeng_id,
    // 'start' => $form_state['values']['text_start'], */
    // 'end' => $form_state['values']['text_end'], */
    'text' => $form_state['values']['cleeng_text'],
    'price' => $prices[$form_state['values']['price']],
    'shortDescription' => $form_state['values']['description'],
    'useLayers' => $form_state['values']['layer_dates'],
    'layersDatesStart' => $form_state['values']['from'] && !is_array($form_state['values']['from']) ? $form_state['values']['from']: '-',
    'layersDatesEnd' => $form_state['values']['to'] && !is_array($form_state['values']['to']) ? $form_state['values']['to']: '-',
    'referral' => $referral_float,
    'new' => ($form_state['values']['cleeng_id'] == ''),
  ));
}

/**
 * Returns a price array
 */
function cleeng_price_array() {
  // Prices array */
  return array(
    '0.00', 0.14, 0.19, 0.24, 0.29, 0.34, 0.39, 0.44, 0.49, 0.54, 0.59, 0.64, 0.69, 0.74, 0.79, 0.84, 0.89, 0.94, 0.99,
    1.24, 1.49, 1.74, 1.99, 2.24, 2.49, 2.74, 2.99, 3.24, 3.49, 3.74, 3.99, 4.24, 4.49, 4.74, 4.99, 5.24, 5.49, 5.74, 5.99,
    6.49, 6.99, 7.49, 7.99, 8.49, 8.99, 9.49, 9.99, 10.49, 10.99, 11.49, 11.99, 12.49, 12.99, 13.49, 13.99, 14.49, 14.99, 15.49, 15.99, 16.49, 16.99, 17.49, 17.99, 18.49, 18.99, 19.49, 19.99,
  );
}

