<?php
/**
 * @file
 * The page callback for cleeng ajax
 */

/**
 * The cleeng server callback for the case of user login and purchase
 */
function cleeng_callback() {
  global $base_url;
  global $user;
  $cleeng = cleeng_client();
  $cleeng->processCallback();

  // User login */
  if ($_GET['cleengMode'] == 'loginCallback') {
    print '<script>opener.location.reload(); window.close();</script>';
  }
  // User purchase success */
  elseif ($_GET['cleengMode'] == 'purchaseCallback') {
    print '<script>opener.location.reload(); window.close();</script>';
  }
  print '<script>window.close();</script>';
}

/**
 * The request for the browser ajax request
 */
function cleeng_ajax_request() {
  $mode = $_REQUEST['cleengMode'];
  global $base_url;
  global $user;

  $cleeng = cleeng_client();

  switch ($mode) {
    case 'auth':
      // Redirect to Cleeng authentication page for user login */
      $cleeng->setOption('callbackUrl', url('cleeng/callback', array('absolute' => TRUE, 'query' => array('cleengMode' => 'loginCallback', 'cleengPopup' => 1, 'backendWidget' => $_REQUEST['backendWidget']))));
      $cleeng->authenticate();
      break;
    case 'loginCallback':
      // Cleeng will return here after authentication. We tell CleengClient */
      // To proceed with OAuth stuff, and close popup window. */
      // Parent window is refreshed so that */
      // Widget will know that user is authenticated status. */
      $cleeng->setOption('callbackUrl', url('cleeng/callback', array('absolute' => TRUE, 'query' => array('cleengMode' => 'loginCallback', 'cleengPopup' => 1, 'backendWidget' => $_REQUEST['backendWidget']))));
      $cleeng->processCallback();
      echo '<script type="text/javascript">
          opener.Cleeng' . ($_REQUEST['backendWidget'] == TRUE ? 'BE' : 'FE') . 'WidgetWP.authUser();
          self.close();
        </script>';
      break;
    case 'purchase':
      // Purchase content */
      $cleeng->setOption('callbackUrl', url('cleeng/callback', array('absolute' => TRUE, 'query' => array('cleengMode' => 'purchaseCallback', 'cleengPopup' => 1, 'contentId' => $_REQUEST['contentId']))));
      try {
        $cleeng->purchaseContent((int) $_REQUEST['contentId']);
      } catch (Exception $e) {

        watchdog('cleeng', 'Exception when purchase: ' . $cleeng->getApiOutputBuffer(), 'error');
      }
      break;
    case 'paypal':
      global $base_root;
      $close_popupUrl = $base_root . '/?q=cleeng/ajax&cleengMode=callback';
      $content_id = intval($_REQUEST['content_id']);

      drupal_set_header('Location: ' . $cleeng->getUrl() . '/content/purchase-digital-goods?'
              . drupal_http_build_query(array(
                  'content_id' => $content_id,
                  'redirect_uri' => $close_popupUrl,
                  'client_id' => $cleeng->getOption('clientId'),
              ), ), );
      break;
    case 'purchaseCallback':
      $cleeng->setOption('callbackUrl', url('cleeng/callback', array('absolute' => TRUE, 'query' => array('cleengMode' => 'purchaseCallback', 'cleengPopup' => 1, 'contentId' => $_REQUEST['contentId']))));
      $cleeng->processCallback();
      if ($cleeng->isUserAuthenticated()) {
        $resp = $cleeng->isContentPurchased(array((int) $_REQUEST['contentId']));
        if ($resp[(int) $_REQUEST['contentId']] == TRUE) {
          echo '<script type="text/javascript">opener.CleengFEWidgetWP.authUser();opener.CleengFEWidgetWP.getcontentinfo();self.close();</script>';
        }
        else {
          echo '<script type="text/javascript">self.close();</script>';
          module_invoke_all('exit');
          exit;
        }
      }
      else {
        echo '<script type="text/javascript">opener.CleengFEWidgetWP.authUser();self.close();</script>';
        module_invoke_all('exit');
        exit;
      }
      break;
    case 'callback':
      try {
        $cleeng->processCallback();
        if ($cleeng->isUserAuthenticated()) {
          setcookie('cleeng_user_auth', 1, time() + 3600 * 24 * 60, '/');
        }
      } catch (Exception $e) {
      }
    case 'closePopup':
      echo '<script>window.parent.location = window.parent.location;top.dg.closeFlow();</script>';
      exit;
    case 'autologin':
      // Check user login when load the page. */
      $id = trim($_REQUEST['id']);
      $key = trim($_REQUEST['key']);

      drupal_set_header('content-type: text/json');

      $cleeng->setOption('callbackUrl', url('cleeng/callback', array('absolute' => TRUE, 'query' => array('cleengMode' => 'loginCallback', 'cleengPopup' => 1, 'backendWidget' => $_REQUEST['backendWidget']))));
      if ($cleeng->isUserAuthenticated()) {
        echo json_encode(array('success' => TRUE));
        module_invoke_all('exit');
        exit;
      }

      if ($id && $key) {
        $ret = $cleeng->autologin($id, $key);
        echo json_encode(array('success' => $ret));
        module_invoke_all('exit');
        exit;
      }
    case 'logout':
      // Disconnect from Cleeng */
      $cleeng->logout();
      if ($_GET['backendWidget'] == 'true') {
        print '<script>window.location = "' . $base_url . '/user/' . $user->uid . '/cleeng";</script>';
      }
      else {
        print '<script>opener.location.reload(); window.close();</script>';
      }
      break;
    case 'vote':
      drupal_set_header('content-type: text/json');
      if ($cleeng->isUserAuthenticated()) {
        $contentid = intval($_REQUEST['contentId']);
        $liked = intval($_REQUEST['liked']);

        if ($contentid > 0 && ($liked == 0 || $liked == 1)) {
          $ret = $cleeng->vote($contentid, $liked);
          echo json_encode($ret['voted']);
        }
      }
      break;
    case 'getUserInfo' :
      drupal_set_header('content-type: text/json');
      if ($cleeng->isUserAuthenticated()) {
        try {
          echo json_encode($cleeng->getUserInfo($_REQUEST['backendWidget']));
        } catch (Exception $e) {

          watchdog('cleeng', 'Exception when getUserInfo: ' . $cleeng->getApiOutputBuffer(), 'error');
        }
      }
      else {
        echo json_encode(array('auth' => FALSE));
      }
      break;
  }
}

if (!function_exists('drupal_http_build_query')) {
  function drupal_http_build_query(array $query, $parent = '') {
    $params = array();

    foreach ($query as $key => $value) {
      $key = ($parent ? $parent . '[' . rawurlencode($key) . ']' : rawurlencode($key));

      // Recurse into children. */
      if (is_array($value)) {
        $params[] = drupal_http_build_query($value, $key);
      }
      // If a query parameter value is NULL, only append its key. */
      elseif (!isset($value)) {
        $params[] = $key;
      }
      else {
        // For better readability */
        $params[] = $key . '=' . str_replace('%2F', '/', rawurlencode($value));
      }
    }

    return implode('&', $params);
  }
}

