Drupal.behaviors.cleengBackend = function (context) {
  // Initial settings
  $('#edit-cleeng').attr('disabled', true);

  // When giving the body field focus
  $('#edit-body').select(function() {
    start = $(this).get(0).selectionStart;
    end = $(this).get(0).selectionEnd;    
      $('#edit-cleeng').attr('disabled', false);
  });
  
  // When deselecting the body field
  $('#edit-body').blur(function() {
      setTimeout("$('#edit-cleeng').attr('disabled', true)", 300);
  });  
}

Drupal.behaviors.cleengModal = function (context) {

  // Process our "Cleeng it!" button also edit buttons, 
  // no submit action, open the modal frame! 
  // If we want to edit or create
  $('.edit-cleeng-item, #edit-cleeng').live('click', function(e) {
    // No submit
    e.preventDefault();
    
    if ($(this).attr('class') == 'edit-cleeng-item') {
      // Edit: add id to url
      var id = $(this).parent().parent().children('td.id').html();
      var description = $(this).parent().parent().children('td.shortDescription').html();
      var price = $(this).parent().parent().children('td.price').html();
      var price = price.substr(1); 
      // Strip sign
      var referral = $(this).parent().parent().children('td.referral').html();
      if (referral != '-') {
        var referral = referral.slice(0, -1);        
      }
      var ls = $(this).parent().parent().children('td.ls').html();
      var le = $(this).parent().parent().children('td.le').html();                                                                                                                                                                                                                                                                                                                          
      var url = Drupal.settings.basePath + 'cleeng/item-form?id=' + id + '&description=' + description + '&price=' + price + '&referral=' + referral + '&ls=' + ls + '&le=' + le;
    } else {
      // Create: Clean url
      var url = Drupal.settings.basePath + 'cleeng/item-form/';
    }
    
    // Modalframe options
    var modalOptions = {
      url: url,
      autoFit: false,
      width: 400,
      height: 520,
      onSubmit: goChangeBody
    };

    // Open the modal frame dialog.
    Drupal.modalFrame.open(modalOptions);
  });
  
  // Remove via the table
  $('.remove-cleeng-item').live('click', function(e) {
        
    e.preventDefault();
    var id = $(this).parent().parent().children('td.id').html();

    pattern = new RegExp('\\[cleeng_content id="' + id + '.+\n+.+\n+\\[\\/cleeng_content\]');

    var all = $('#edit-body').val().match(pattern);

    var all = all.toString().split(']');
    var all = all[1].split('[');

    // Apply changes to the body
    $('#edit-body').val($('#edit-body').val().replace(pattern, all[0].trim()));
    
    // Remove the whole row
    // console.log($('#cleeng-content-table tr').length);
    if ($('#cleeng-content-table tr').size() == 2) {
      $('#cleeng-content-table').hide();
      $(this).parent().parent().remove();    
      $('#cleeng-no-items').show();  
      stripeTable($('#cleeng-content-table'));    
    }    
    $(this).parent().parent().fadeOut('slow', function() {
      $(this).remove();
      stripeTable($('#cleeng-content-table'));    
    });
  });

  // Recalculate odd & even for the table
  function stripeTable(table) {
    $("tr:even", table).removeClass("odd");
    $("tr:odd", table).removeClass("even");
    $("tr:odd:not('.odd')", table).addClass("odd");
    $("tr:even:not('.even')", table).addClass("even");    
  }


  // This function is called after adding a new cleeng item
  goChangeBody = function (args) {
  	console.log(Drupal.settings.wysiwyg);
    if (args.shortDescription) {

      // Here we build the bbcode for cleeng 
      // Needs to look like:

      /*
      [cleeng_content id="t1" price="0.89" description="beschrijving" referral="0.5" ls="2011-08-04 14:22" le="2011-08-31 09:23"]
      */
      
      var elementToAddTo = '';      
      
      // Standard      
      var bbCode = '[cleeng_content id="' + args.id + '" description="' + args.shortDescription + '" price="' + args.price + '"';       
       
      // Referral
      if (args.referral != '-') { bbCode = bbCode + ' referral="' + args.referral + '"'; }
      
      // Layer date start
      if (args.layersDatesStart != '-' && args.useLayers == true) { bbCode = bbCode + ' ls="' + args.layersDatesStart + '"'; }      
      
      // Layer date end
      if (args.layersDatesEnd != '-'  && args.useLayers == true) { bbCode = bbCode + ' le="' + args.layersDatesEnd + '"'; }     

      // First part and put it in place (New or existing)
      if (args.new == false){
        // This is a existing one, so we replace the old tag
        // console.log(args.id);
        pattern = new RegExp('\\[cleeng_content id="' + args.id + '.+?\]'); 

 				if(Drupal.settings.ckeditor && Drupal.settings.ckeditor.settings['edit-body'] || Drupal.settings.wysiwyg) {
					returnData = cleengGetData().replace(pattern, bbCode + ']');
					// console.log(cleengGetData());
				} else {       
	        $('#edit-body').val($('#edit-body').val().replace(pattern, bbCode + ']'));
  			}      
        var elementToChange = $('td[id="' + args.id + '"]').parent();
      } else {
        // This is a new one, simple add the tag to the body

        // Add data and close bbCode

				if(Drupal.settings.ckeditor && Drupal.settings.ckeditor.settings['edit-body'] || Drupal.settings.wysiwyg) {
        	var bbCode = bbCode + ']<br />' + args.text + '<br />[/cleeng_content]';  					
					returnData = cleengGetData().replace(args.text, bbCode);
				} else {
        	var bbCode = bbCode + ']\n' + args.text + '\n[/cleeng_content]';  
					$('#edit-body').val($('#edit-body').val().replace(args.text, bbCode));	
				}  	       
      }      

      // Here we start with markup        
      $('#cleeng-content-table').show();
      $('#cleeng-no-items').hide();
        
      // Fixing some markup
      if (args.referral != '-'){
        splitted= args.referral.split('.');
        var referral = parseFloat(splitted[1]) + '%';
      } else {
        var referral = '-';  
      }
      if (args.useLayers == false) {
        args.layersDatesStart = '-';
        args.layersDatesEnd = '-';
      }
      
      // console.log(args);      
      // console.log(elementToAddTo);
      
      // Create a table row to attach
      tableRow = '<tr class="odd">' +
      '<td class="id" id="' + args.id + '">' + args.id + '</td>' +
      '<td class="shortDescription">' + args.shortDescription + '</td>' +
      '<td class="price">' + Drupal.settings.cleeng.currency + args.price + '</td>' +
      '<td class="ls">' + args.layersDatesStart + '</td>' +
      '<td class="le">' + args.layersDatesEnd + '</td>' +
      '<td class="referral">' + referral + '</td>' +    
      '<td><a class="edit-cleeng-item" href="#">Edit</a></td>' +
      '<td><a class="remove-cleeng-item" href="#">Remove</a></td>' +                                       
      '</tr>';
      
      if (args.new == false){
        // Old one
        elementToChange.after(tableRow);
        elementToChange.remove();
      } else {
        // New one
        if ($('#cleeng-content-table tr').length == 0) {
          // No items
          $('#cleeng-content-table').show().wrap(tableRow);
        } else {
          // We got some items
          $('#cleeng-content-table tr:last').after(tableRow);
        }
      } 
        
      // Rebuild table striping
      stripeTable($('#cleeng-content-table'));
    }
	if(Drupal.settings.ckeditor && Drupal.settings.ckeditor.settings['edit-body'] || Drupal.settings.wysiwyg) {    
		cleengSetData(returnData);
	}    
  }
}

