/**
 * @file Plugin for protecting content with Cleeng.
 */
CKEDITOR.plugins.add( 'cleeng',
{
  requires  : [ 'fakeobjects', 'htmldataprocessor' ],

  init : function( editor )
  {

    // Register the toolbar buttons.
    editor.ui.addButton( 'cleeng',
      {
        label : Drupal.t('Protect section with Cleeng'),
        icon : this.path + 'images/btn.png',
        command : 'cleeng'
    });

    cleengSetData = function (data) {
      editor.setData(data);
    }
			
    cleengGetData = function () {
      return editor.getSnapshot();
    }			
    cleengGetSelection = function () {
      return editor.getSelection().getSelectedText();
    }		

    // Delete other button
    $('#edit-cleeng').remove();

    // Register the commands.

    editor.addCommand( 'cleeng',
    {
      exec : function()
      {
        var mySelection = editor.getSelection();

        if (CKEDITOR.env.ie) {
          mySelection.unlock(true);
          selectedText = mySelection.getNative().createRange().text;
        } else {
          selectedText = mySelection.getNative();
        }
        if(selectedText == '') {
        	alert(Drupal.t('Please make a selection first.'));
        } else {
          var url = Drupal.settings.basePath + 'cleeng/item-form/';
    
          // Modalframe options
          var modalOptions = {
            url: url,
            autoFit: false,
            width: 400,
            height: 520,
            onSubmit: goChangeBody
          };

          // Open the modal frame dialog.
          Drupal.modalFrame.open(modalOptions);
        }
      }
    });
  },
});

